#! /bin/sh
# Test of gettext facilities in the C# language.
# Assumes an fr_FR locale is installed.
# Assumes the following packages are installed: pnet, pnetlib.
# Note: This test fails with mono-0.28 because the CultureInfo.Parent pointers
# are wrong for locales containing a language and a territory. This is fixed
# in mono-0.29.
tmpfiles=""
trap 'rm -fr $tmpfiles' 1 2 3 15
# Test whether we can build and test C# programs.
test "${CSHARP_CHOICE}" != no || {
echo "Skipping test: configured with --disable-csharp"
exit 77
}
test "${BUILDCSHARP}" = yes || {
echo "Skipping test: C# compiler not found"
exit 77
}
test "${TESTCSHARP}" = yes || {
echo "Skipping test: C# engine not found"
exit 77
}
tmpfiles="$tmpfiles program.cs"
cat <<\EOF > program.cs
using System;
using GNU.Gettext;
class Program {
static void Main (String[] args) {
#if __MonoCS__
// Some systems don't set CurrentCulture and CurrentUICulture as specified
// by LC_ALL. So set it by hand.
System.Threading.Thread.CurrentThread.CurrentCulture =
System.Threading.Thread.CurrentThread.CurrentUICulture =
new System.Globalization.CultureInfo("fr-FR");
#endif
int n = Int32.Parse(args[0]);
GettextResourceManager catalog = new GettextResourceManager("prog");
Console.WriteLine(catalog.GetString("'Your command, please?', asked the waiter."));
Console.WriteLine(String.Format(catalog.GetPluralString("a piece of cake","{0} pieces of cake",n), n));
Console.WriteLine(String.Format(catalog.GetString("{0} is replaced by {1}."), "FF", "EUR"));
}
}
EOF
tmpfiles="$tmpfiles program.exe"
: ${CSHARPCOMP="/bin/sh ../csharpcomp.sh"}
${CSHARPCOMP} -o program.exe -L ../../gettext-runtime/intl-csharp -l GNU.Gettext program.cs || exit 1
tmpfiles="$tmpfiles prog.pot"
: ${XGETTEXT=xgettext}
${XGETTEXT} -o prog.pot --omit-header --no-location program.cs
tmpfiles="$tmpfiles prog.ok"
cat <<EOF > prog.ok
msgid "'Your command, please?', asked the waiter."
msgstr ""
#, csharp-format
msgid "a piece of cake"
msgid_plural "{0} pieces of cake"
msgstr[0] ""
msgstr[1] ""
#, csharp-format
msgid "{0} is replaced by {1}."
msgstr ""
EOF
: ${DIFF=diff}
${DIFF} prog.ok prog.pot || exit 1
tmpfiles="$tmpfiles fr.po"
cat <<\EOF > fr.po
msgid ""
msgstr ""
"Content-Type: text/plain; charset=ISO-8859-1\n"
"Plural-Forms: nplurals=2; plural=(n > 1);\n"
msgid "'Your command, please?', asked the waiter."
msgstr "«Votre commande, s'il vous plait», dit le garçon."
# Les gateaux allemands sont les meilleurs du monde.
#, csharp-format
msgid "a piece of cake"
msgid_plural "{0} pieces of cake"
msgstr[0] "un morceau de gateau"
msgstr[1] "{0} morceaux de gateau"
# Reverse the arguments.
#, csharp-format
msgid "{0} is replaced by {1}."
msgstr "{1} remplace {0}."
EOF
tmpfiles="$tmpfiles fr.po.new"
: ${MSGMERGE=msgmerge}
${MSGMERGE} -q -o fr.po.new fr.po prog.pot
: ${DIFF=diff}
${DIFF} fr.po fr.po.new || exit 1
tmpfiles="$tmpfiles fr/prog.dll"
: ${MSGFMT=msgfmt}
GETTEXTCSHARPLIBDIR=../../gettext-runtime/intl-csharp \
${MSGFMT} --csharp -d . -r prog -l fr fr.po || exit 1
# Test which of the fr_FR locales are installed.
: ${LOCALE_FR=fr_FR}
: ${LOCALE_FR_UTF8=fr_FR.UTF-8}
if test $LOCALE_FR != none; then
LC_ALL=$LOCALE_FR ./testlocale
case $? in
0) ;;
77) LOCALE_FR=none;;
*) exit 1;;
esac
fi
if test $LOCALE_FR_UTF8 != none; then
LC_ALL=$LOCALE_FR_UTF8 ./testlocale
case $? in
0) ;;
77) LOCALE_FR_UTF8=none;;
*) exit 1;;
esac
fi
if test $LOCALE_FR = none && test $LOCALE_FR_UTF8 = none; then
if test -f /usr/bin/localedef; then
echo "Skipping test: no french locale is installed"
else
echo "Skipping test: no french locale is supported"
fi
rm -fr $tmpfiles; exit 77
fi
tmpfiles="$tmpfiles prog.ok prog.oku prog.out"
: ${DIFF=diff}
cat <<\EOF > prog.ok
«Votre commande, s'il vous plait», dit le garçon.
2 morceaux de gateau
EUR remplace FF.
EOF
cat <<\EOF > prog.oku
«Votre commande, s'il vous plait», dit le garçon.
2 morceaux de gateau
EUR remplace FF.
EOF
: ${LOCALE_FR=fr_FR}
: ${LOCALE_FR_UTF8=fr_FR.UTF-8}
: ${CSHARPEXEC="/bin/sh ../csharpexec.sh"}
if test $LOCALE_FR != none; then
LANGUAGE= LC_ALL=$LOCALE_FR ${CSHARPEXEC} -L ../../gettext-runtime/intl-csharp program.exe 2 > prog.out || exit 1
${DIFF} prog.ok prog.out || exit 1
fi
if test $LOCALE_FR_UTF8 != none; then
LANGUAGE= LC_ALL=$LOCALE_FR_UTF8 ${CSHARPEXEC} -L ../../gettext-runtime/intl-csharp program.exe 2 > prog.out || exit 1
${DIFF} prog.oku prog.out || exit 1
fi
rm -fr $tmpfiles
exit 0